gtkmm: Gtk::DragSource Class Reference

gtkmm 4.22.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::DragSource Class Reference
Event Controllers and Gestures

Event controller to initiate DND operations. More...

`#include <gtkmm/dragsource.h>`

Inheritance diagram for Gtk::DragSource:
[legend]

## Public Member Functions
| DragSource (DragSource &&src) noexcept
DragSource & | operator= (DragSource &&src) noexcept
| ~DragSource () noexcept override
GtkDragSource * | gobj ()
| Provides access to the underlying C GObject.
const GtkDragSource * | gobj () const
| Provides access to the underlying C GObject.
GtkDragSource * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_content (const Glib::RefPtr< Gdk::ContentProvider > &content)
| Sets a content provider on a `Gtk::DragSource`.
Glib::RefPtr< Gdk::ContentProvider > | get_content ()
| Gets the current content provider of a `Gtk::DragSource`.
Glib::RefPtr< const Gdk::ContentProvider > | get_content () const
| Gets the current content provider of a `Gtk::DragSource`.
void | set_actions (Gdk::DragAction actions)
| Sets the actions on the `Gtk::DragSource`.
Gdk::DragAction | get_actions () const
| Gets the actions that are currently set on the `Gtk::DragSource`.
void | set_icon (const Glib::RefPtr< const Gdk::Paintable > &paintable, int hot_x, int hot_y)
| Sets a paintable to use as icon during DND operations.
void | drag_cancel ()
| Cancels a currently ongoing drag operation.
Glib::RefPtr< Gdk::Drag > | get_drag ()
| Returns the underlying `Gdk::Drag` object for an ongoing drag.
Glib::RefPtr< const Gdk::Drag > | get_drag () const
| Returns the underlying `Gdk::Drag` object for an ongoing drag.
Glib::PropertyProxy< Glib::RefPtr< Gdk::ContentProvider > > | property_content ()
| The data that is offered by drag operations from this source.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::ContentProvider > > | property_content () const
| The data that is offered by drag operations from this source.
Glib::PropertyProxy< Gdk::DragAction > | property_actions ()
| The actions that are supported by drag operations from the source.
Glib::PropertyProxy_ReadOnly< Gdk::DragAction > | property_actions () const
| The actions that are supported by drag operations from the source.
Glib::SignalProxy< Glib::RefPtr< Gdk::ContentProvider >(double, double)> | signal_prepare ()
| Only one signal handler is called.
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::Drag > &)> | signal_drag_begin ()
Glib::SignalProxy< void(const Glib::RefPtr< Gdk::Drag > &, bool)> | signal_drag_end ()
Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::Drag > &, Gdk::DragCancelReason)> | signal_drag_cancel ()
Public Member Functions inherited from Gtk::GestureSingle
| GestureSingle (GestureSingle &&src) noexcept
GestureSingle & | operator= (GestureSingle &&src) noexcept
| ~GestureSingle () noexcept override
GtkGestureSingle * | gobj ()
| Provides access to the underlying C GObject.
const GtkGestureSingle * | gobj () const
| Provides access to the underlying C GObject.
GtkGestureSingle * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | get_touch_only () const
| Returns `true` if the gesture is only triggered by touch events.
void | set_touch_only (bool touch_only=true)
| Sets whether to handle only touch events.
bool | get_exclusive () const
| Gets whether a gesture is exclusive.
void | set_exclusive (bool exclusive=true) const
| Sets whether gesture is exclusive.
unsigned int | get_button () const
| Returns the button number gesture listens for.
void | set_button (unsigned int button=0)
| Sets the button number gesture listens to.
unsigned int | get_current_button () const
| Returns the button number currently interacting with gesture, or 0 if there is none.
Gdk::EventSequence * | get_current_sequence ()
| Returns the event sequence currently interacting with gesture.
const Gdk::EventSequence * | get_current_sequence () const
| Returns the event sequence currently interacting with gesture.
Glib::PropertyProxy< bool > | property_touch_only ()
| Whether the gesture handles only touch events.
Glib::PropertyProxy_ReadOnly< bool > | property_touch_only () const
| Whether the gesture handles only touch events.
Glib::PropertyProxy< bool > | property_exclusive ()
| Whether the gesture is exclusive.
Glib::PropertyProxy_ReadOnly< bool > | property_exclusive () const
| Whether the gesture is exclusive.
Glib::PropertyProxy< unsigned int > | property_button ()
| Mouse button number to listen to, or 0 to listen for any button.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_button () const
| Mouse button number to listen to, or 0 to listen for any button.
Public Member Functions inherited from Gtk::Gesture
| Gesture (Gesture &&src) noexcept
Gesture & | operator= (Gesture &&src) noexcept
| ~Gesture () noexcept override
GtkGesture * | gobj ()
| Provides access to the underlying C GObject.
const GtkGesture * | gobj () const
| Provides access to the underlying C GObject.
GtkGesture * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the logical `Gdk::Device` that is currently operating on gesture.
Glib::RefPtr< const Gdk::Device > | get_device () const
| Returns the logical `Gdk::Device` that is currently operating on gesture.
bool | set_state (EventSequenceState state)
| Sets the state of all sequences that gesture is currently interacting with.
EventSequenceState | get_sequence_state (Gdk::EventSequence *sequence) const
| Returns the sequence state, as seen by gesture.
bool | set_sequence_state (Gdk::EventSequence *sequence, EventSequenceState state)
| Sets the state of sequence in gesture.
std::vector< const Gdk::EventSequence * > | get_sequences () const
| Returns the list of Gdk::EventSequences currently being interpreted.
Gdk::EventSequence * | get_last_updated_sequence ()
| Returns the `Gdk::EventSequence` that was last updated on gesture.
const Gdk::EventSequence * | get_last_updated_sequence () const
| Returns the `Gdk::EventSequence` that was last updated on gesture.
bool | handles_sequence (Gdk::EventSequence *sequence) const
| Returns `true` if gesture is currently handling events corresponding to sequence.
Glib::RefPtr< Gdk::Event > | get_last_event (Gdk::EventSequence *sequence)
| Returns the last event that was processed for sequence.
Glib::RefPtr< const Gdk::Event > | get_last_event (Gdk::EventSequence *sequence) const
| Returns the last event that was processed for sequence.
bool | get_point (Gdk::EventSequence *sequence, double &x, double &y) const
| If sequence is currently being interpreted by gesture, returns `true` and fills in x and y with the last coordinates stored for that event sequence.
bool | get_bounding_box (Gdk::Rectangle &rect) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in rect with the bounding box containing all active touches.
bool | get_bounding_box_center (double &x, double &y) const
| If there are touch sequences being currently handled by gesture, returns `true` and fills in x and y with the center of the bounding box containing all active touches.
bool | is_active () const
| Returns `true` if the gesture is currently active.
bool | is_recognized () const
| Returns `true` if the gesture is currently recognized.
void | group (const Glib::RefPtr< Gesture > &group_gesture)
| Adds gesture to the same group than group_gesture.
void | ungroup ()
| Separates gesture into an isolated group.
std::vector< Glib::RefPtr< Gesture > > | get_group ()
| Returns all gestures in the group of gesture.
std::vector< Glib::RefPtr< const Gesture > > | get_group () const
| Returns all gestures in the group of gesture.
bool | is_grouped_with (const Glib::RefPtr< Gesture > &other) const
| Returns `true` if both gestures pertain to the same group.
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_begin ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_end ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_update ()
Glib::SignalProxy< void(Gdk::EventSequence *)> | signal_cancel ()
Glib::SignalProxy< void(Gdk::EventSequence *, EventSequenceState)> | signal_sequence_state_changed ()
Glib::PropertyProxy_ReadOnly< unsigned int > | property_n_points () const
| The number of touch points that trigger recognition on this gesture.
Public Member Functions inherited from Gtk::EventController
| EventController (EventController &&src) noexcept
EventController & | operator= (EventController &&src) noexcept
| ~EventController () noexcept override
GtkEventController * | gobj ()
| Provides access to the underlying C GObject.
const GtkEventController * | gobj () const
| Provides access to the underlying C GObject.
GtkEventController * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Widget * | get_widget ()
| Returns the `Gtk::Widget` this controller relates to.
const Widget * | get_widget () const
| Returns the `Gtk::Widget` this controller relates to.
void | reset ()
| Resets the controller to a clean state.
PropagationPhase | get_propagation_phase () const
| Gets the propagation phase at which controller handles events.
void | set_propagation_phase (PropagationPhase phase)
| Sets the propagation phase at which a controller handles events.
PropagationLimit | get_propagation_limit () const
| Gets the propagation limit of the event controller.
void | set_propagation_limit (PropagationLimit limit)
| Sets the event propagation limit on the event controller.
Glib::ustring | get_name () const
| Gets the name of controller.
void | set_name (const Glib::ustring & name)
| Sets a name on the controller that can be used for debugging.
Glib::RefPtr< const Gdk::Event > | get_current_event () const
| Returns the event that is currently being handled by the controller.
guint32 | get_current_event_time () const
| Returns the timestamp of the event that is currently being handled by the controller.
Glib::RefPtr< Gdk::Device > | get_current_event_device ()
| Returns the device of the event that is currently being handled by the controller.
Glib::RefPtr< const Gdk::Device > | get_current_event_device () const
| Returns the event that is currently being handled by the controller.
Gdk::ModifierType | get_current_event_state () const
| Returns the modifier state of the event that is currently being handled by the controller.
Glib::PropertyProxy_ReadOnly< Widget * > | property_widget () const
| The widget receiving the `Gdk::Events` that the controller will handle.
Glib::PropertyProxy< PropagationPhase > | property_propagation_phase ()
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy_ReadOnly< PropagationPhase > | property_propagation_phase () const
| The propagation phase at which this controller will handle events.
Glib::PropertyProxy< PropagationLimit > | property_propagation_limit ()
| The limit for which events this controller will handle.
Glib::PropertyProxy_ReadOnly< PropagationLimit > | property_propagation_limit () const
| The limit for which events this controller will handle.
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name for this controller, typically used for debugging purposes.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name for this controller, typically used for debugging purposes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< DragSource > | create ()
Static Public Member Functions inherited from Gtk::GestureSingle
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Gesture
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::EventController
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| DragSource ()
Protected Member Functions inherited from Gtk::GestureSingle
| GestureSingle ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Gtk::Gesture
| Gesture ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Gtk::EventController
| EventController ()
| There is no create() method that corresponds to this constructor, because only derived classes shall be created.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::DragSource > | wrap (GtkDragSource *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::GestureSingle
Glib::RefPtr< Gtk::GestureSingle > | wrap (GtkGestureSingle *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Gesture
Glib::RefPtr< Gtk::Gesture > | wrap (GtkGesture *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::EventController
Glib::RefPtr< Gtk::EventController > | wrap (GtkEventController *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Event controller to initiate DND operations.

Gtk::DragSource is an auxiliary object that is used to initiate Drag-And-Drop operations. It can be set up with the necessary ingredients for a DND operation ahead of time. This includes the source for the data that is being transferred, in the form of a Gdk::ContentProvider, the desired action, and the icon to use during the drag operation. After setting it up, the drag source must be added to a widget as an event controller, using Gtk::Widget::add_controller().

Setting up the content provider and icon ahead of time only makes sense when the data does not change. More commonly, you will want to set them up just in time. To do so, Gtk::DragSource has signal_prepare() and signal_drag_begin(). The prepare signal is emitted before a drag is started, and can be used to set the content provider and actions that the drag should be started with. The drag-begin signal is emitted after the Gdk::Drag object has been created, and can be used to set up the drag icon.

During the DND operation, Gtk::DragSource emits signals that can be used to obtain updates about the status of the operation, but it is not normally necessary to connect to any signals, except for one case: when the supported actions include Gdk::DragAction::MOVE, you need to listen for signal_drag_end() and delete the data after it has been transferred.

Since gtkmm 3.96:

## Constructor & Destructor Documentation

## ◆ DragSource() [1/2]

Gtk::DragSource::DragSource | ( | DragSource && | src | ) |
| noexcept

## ◆ ~DragSource()

Gtk::DragSource::~DragSource | ( |  | ) |
| overridenoexcept

## ◆ DragSource() [2/2]

Gtk::DragSource::DragSource | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< DragSource > Gtk::DragSource::create | ( |  | ) |
| static

## ◆ drag_cancel()

void Gtk::DragSource::drag_cancel | ( |  | ) |

Cancels a currently ongoing drag operation.

## ◆ get_actions()

Gdk::DragAction Gtk::DragSource::get_actions | ( |  | ) | const

Gets the actions that are currently set on the `Gtk::DragSource`.

Returns
  The actions set on source.

## ◆ get_content() [1/2]

Glib::RefPtr< Gdk::ContentProvider > Gtk::DragSource::get_content | ( |  | ) |

Gets the current content provider of a `Gtk::DragSource`.

Returns
  The `Gdk::ContentProvider` of source.

## ◆ get_content() [2/2]

Glib::RefPtr< const Gdk::ContentProvider > Gtk::DragSource::get_content | ( |  | ) | const

Gets the current content provider of a `Gtk::DragSource`.

Returns
  The `Gdk::ContentProvider` of source.

## ◆ get_drag() [1/2]

Glib::RefPtr< Gdk::Drag > Gtk::DragSource::get_drag | ( |  | ) |

Returns the underlying `Gdk::Drag` object for an ongoing drag.

Returns
  The `Gdk::Drag` of the current drag operation.

## ◆ get_drag() [2/2]

Glib::RefPtr< const Gdk::Drag > Gtk::DragSource::get_drag | ( |  | ) | const

Returns the underlying `Gdk::Drag` object for an ongoing drag.

Returns
  The `Gdk::Drag` of the current drag operation.

## ◆ get_type()

static GType Gtk::DragSource::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkDragSource * Gtk::DragSource::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkDragSource * Gtk::DragSource::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkDragSource * Gtk::DragSource::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

DragSource & Gtk::DragSource::operator= | ( | DragSource && | src | ) |
| noexcept

## ◆ property_actions() [1/2]

Glib::PropertyProxy< Gdk::DragAction > Gtk::DragSource::property_actions | ( |  | ) |

The actions that are supported by drag operations from the source.

Note that you must handle the signal_drag_end() signal if the actions include Gdk::DragAction::MOVE.

Default value: Gdk::DragAction::COPY

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_actions() [2/2]

Glib::PropertyProxy_ReadOnly< Gdk::DragAction > Gtk::DragSource::property_actions | ( |  | ) | const

The actions that are supported by drag operations from the source.

Note that you must handle the signal_drag_end() signal if the actions include Gdk::DragAction::MOVE.

Default value: Gdk::DragAction::COPY

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_content() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Gdk::ContentProvider > > Gtk::DragSource::property_content | ( |  | ) |

The data that is offered by drag operations from this source.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_content() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::ContentProvider > > Gtk::DragSource::property_content | ( |  | ) | const

The data that is offered by drag operations from this source.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_actions()

void Gtk::DragSource::set_actions | ( | Gdk::DragAction | actions | ) |

Sets the actions on the `Gtk::DragSource`.

During a DND operation, the actions are offered to potential drop targets. If actions include Gdk::DragAction::MOVE, you need to listen to the signal_drag_end() signal and handle delete_data being `true`.

This function can be called before a drag is started, or in a handler for the signal_prepare() signal.

Parameters

  actions | The actions to offer.

## ◆ set_content()

void Gtk::DragSource::set_content | ( | const Glib::RefPtr< Gdk::ContentProvider > & | content | ) |

Sets a content provider on a `Gtk::DragSource`.

When the data is requested in the cause of a DND operation, it will be obtained from the content provider.

This function can be called before a drag is started, or in a handler for the signal_prepare() signal.

You may consider setting the content provider back to `nullptr` in a signal_drag_end() signal handler.

Parameters

  content | A `Gdk::ContentProvider`.

## ◆ set_icon()

void Gtk::DragSource::set_icon | ( | const Glib::RefPtr< const Gdk::Paintable > & | paintable,
|  | int | hot_x,
|  | int | hot_y
| ) |  |

Sets a paintable to use as icon during DND operations.

The hotspot coordinates determine the point on the icon that gets aligned with the hotspot of the cursor.

If paintable is `nullptr`, a default icon is used.

This function can be called before a drag is started, or in a signal_prepare() or signal_drag_begin() signal handler.

Parameters

  paintable | The `Gdk::Paintable` to use as icon.
  hot_x | The hotspot X coordinate on the icon.
  hot_y | The hotspot Y coordinate on the icon.

## ◆ signal_drag_begin()

Glib::SignalProxy< void(const Glib::RefPtr< Gdk::Drag > &)> Gtk::DragSource::signal_drag_begin | ( |  | ) |

Slot Prototype:
  `void on_my_drag_begin(const Glib::RefPtr<Gdk::Drag>& drag)`

Flags: Run Last

Emitted on the drag source when a drag is started.

It can be used to e.g. set a custom drag icon with Gtk::DragSource::set_icon().

Parameters

  drag | The `Gdk::Drag` object.

## ◆ signal_drag_cancel()

Glib::SignalProxy< bool(const Glib::RefPtr< Gdk::Drag > &, Gdk::DragCancelReason)> Gtk::DragSource::signal_drag_cancel | ( |  | ) |

Slot Prototype:
  `bool on_my_drag_cancel(const Glib::RefPtr<Gdk::Drag>& drag, Gdk::DragCancelReason reason)`

Flags: Run Last

Emitted on the drag source when a drag has failed.

The signal handler may handle a failed drag operation based on the type of error. It should return `true` if the failure has been handled and the default "drag operation failed" animation should not be shown.

Parameters

  drag | The `Gdk::Drag` object.
  reason | Information on why the drag failed.

Returns
  `true` if the failed drag operation has been already handled.

## ◆ signal_drag_end()

Glib::SignalProxy< void(const Glib::RefPtr< Gdk::Drag > &, bool)> Gtk::DragSource::signal_drag_end | ( |  | ) |

Slot Prototype:
  `void on_my_drag_end(const Glib::RefPtr<Gdk::Drag>& drag, bool delete_data)`

Flags: Run Last

Emitted on the drag source when a drag is finished.

A typical reason to connect to this signal is to undo things done in signal_prepare() or signal_drag_begin() handlers.

Parameters

  drag | The `Gdk::Drag` object.
  delete_data | `true` if the drag was performing Gdk::DragAction::MOVE, and the data should be deleted.

## ◆ signal_prepare()

Glib::SignalProxy< Glib::RefPtr< Gdk::ContentProvider >(double, double)> Gtk::DragSource::signal_prepare | ( |  | ) |

Only one signal handler is called.

If you connect a handler, it must be called before (instead of) the default handler, otherwise it won't be called. Set the after parameter in connect() to `false`.

Slot Prototype:
  `Glib::RefPtr<Gdk::ContentProvider> on_my_prepare(double x, double y)`

Flags: Run Last

Emitted when a drag is about to be initiated.

It returns the `Gdk::ContentProvider` to use for the drag that is about to start. The default handler for this signal returns the value of the property_content() property, so if you set up that property ahead of time, you don't need to connect to this signal.

Parameters

  x | The X coordinate of the drag starting point.
  y | The Y coordinate of the drag starting point.

Returns
  A `Gdk::ContentProvider`.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::DragSource > wrap | ( | GtkDragSource * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.